Debian Bug report logs - #657751
gdm3: error on package purge

version graph

Package: gdm3; Maintainer for gdm3 is Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>; Source for gdm3 is src:gdm3.

Reported by: Yann Dirson <ydirson@free.fr>

Date: Sat, 28 Jan 2012 15:48:01 UTC

Severity: serious

Tags: patch

Found in version gdm3/3.0.4-4

Fixed in version gdm3/3.4.1-4

Done: Simon McVittie <smcv@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>:
Bug#657751; Package gdm3. (Sat, 28 Jan 2012 15:48:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Yann Dirson <ydirson@free.fr>:
New Bug report received and forwarded. Copy sent to Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>. (Sat, 28 Jan 2012 15:48:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Yann Dirson <ydirson@free.fr>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: gdm3: error on package purge
Date: Sat, 28 Jan 2012 16:07:16 +0100
Package: gdm3
Version: 3.0.4-4
Severity: serious

Removing gdm3 ...
Purging configuration files for gdm3 ...
insserv: warning: script 'K02evms' missing LSB tags and overrides
insserv: warning: script 'S20LOCAL-fw' missing LSB tags and overrides
insserv: warning: script 'evms' missing LSB tags and overrides
insserv: warning: script 'LOCAL-fw' missing LSB tags and overrides
Removing user `Debian-gdm' ...
Warning: group `Debian-gdm' has no more members.
userdel: user Debian-gdm is currently logged in
/usr/sbin/deluser: `/usr/sbin/userdel Debian-gdm' returned error code 8. Exiting.
Could not remove Debian-gdm user.
/usr/sbin/delgroup: `Debian-gdm' still has `Debian-gdm' as their primary group!
Could not remove Debian-gdm group.
insserv: warning: script 'K02evms' missing LSB tags and overrides
insserv: warning: script 'S20LOCAL-fw' missing LSB tags and overrides
insserv: warning: script 'evms' missing LSB tags and overrides
insserv: warning: script 'LOCAL-fw' missing LSB tags and overrides
userdel: user Debian-gdm is currently logged in
/usr/sbin/deluser: `/usr/sbin/userdel Debian-gdm' returned error code 8. Exiting.
/usr/sbin/delgroup: `Debian-gdm' still has `Debian-gdm' as their primary group!
dpkg: error processing gdm3 (--purge):
 subprocess installed post-removal script returned error exit status 128
Processing triggers for man-db ...
configured to not write apport reports
                                      Processing triggers for gconf2 ...
Processing triggers for hicolor-icon-theme ...
Errors were encountered while processing:
 gdm3
E: Sub-process /usr/bin/dpkg returned an error code (1)


-- System Information:
Debian Release: wheezy/sid
  APT prefers testing
  APT policy: (990, 'testing'), (500, 'unstable'), (500, 'stable'), (500, 'oldstable'), (101, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 3.1.0-1-amd64 (SMP w/4 CPU cores)
Locale: LANG=C, LC_CTYPE=fr_FR.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages gdm3 depends on:
ii  accountsservice                    0.6.15-2
ii  adduser                            3.113
ii  awesome [x-window-manager]         3.4.11-1
ii  dconf-gsettings-backend            0.10.0-3
ii  debconf [debconf-2.0]              1.5.41
ii  flwm [x-window-manager]            1.02+cvs20080422-9
ii  fvwm [x-window-manager]            1:2.5.30.ds-1
ii  gconf2                             2.32.4-1
ii  gnome-session-bin                  3.2.1-1
ii  gsettings-desktop-schemas          3.2.0-2
ii  libaccountsservice0                0.6.15-2
ii  libatk1.0-0                        2.2.0-2
ii  libattr1                           1:2.4.46-5
ii  libaudit0                          1.7.18-1
ii  libc6                              2.13-24
ii  libcairo-gobject2                  1.10.2-6.2
ii  libcairo2                          1.10.2-6.2
ii  libcanberra-gtk3-0                 0.28-3
ii  libcanberra0                       0.28-3
ii  libdbus-1-3                        1.4.16-1
ii  libdbus-glib-1-2                   0.98-1
ii  libfontconfig1                     2.8.0-3
ii  libfreetype6                       2.4.8-1
ii  libgconf2-4                        2.32.4-1
ii  libgdk-pixbuf2.0-0                 2.24.0-2
ii  libglib2.0-0                       2.30.2-4
ii  libglib2.0-bin                     2.30.2-4
ii  libgtk-3-0                         3.2.3-1
ii  libpam-modules                     1.1.3-6
ii  libpam-runtime                     1.1.3-6
ii  libpam0g                           1.1.3-6
ii  libpango1.0-0                      1.29.4-2
ii  librsvg2-common                    2.34.2-2
ii  libselinux1                        2.1.0-4
ii  libupower-glib1                    0.9.15-1
ii  libwrap0                           7.6.q-22
ii  libx11-6                           2:1.4.4-4
ii  libxau6                            1:1.0.6-4
ii  libxdmcp6                          1:1.1.0-4
ii  libxklavier16                      5.1-3
ii  libxrandr2                         2:1.3.2-2
ii  lsb-base                           3.2-28
ii  lxsession [x-session-manager]      0.4.6.1-1
ii  openbox [x-window-manager]         3.5.0-2
ii  policykit-1-gnome                  0.105-1
ii  upower                             0.9.15-1
ii  xfce4-session [x-session-manager]  4.8.2-3
ii  xfwm4 [x-window-manager]           4.8.3-1
ii  xterm [x-terminal-emulator]        276-2

Versions of packages gdm3 recommends:
ii  at-spi                 1.32.0-1
ii  desktop-base           6.0.7
ii  gnome-icon-theme       3.2.1.2-1
ii  gnome-power-manager    <none>
ii  gnome-settings-daemon  <none>
ii  x11-xkb-utils          7.6+4
ii  xserver-xephyr         2:1.11.3.901-2
ii  xserver-xorg           1:7.5+8
ii  zenity                 3.2.0-1

Versions of packages gdm3 suggests:
pn  gnome-mag             <none>
pn  gnome-orca            <none>
pn  gok                   <none>
pn  libpam-gnome-keyring  3.2.2-1
pn  metacity              <none>




Information forwarded to debian-bugs-dist@lists.debian.org, Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>:
Bug#657751; Package gdm3. (Sun, 11 Mar 2012 03:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Paul Wise <pabs@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>. (Sun, 11 Mar 2012 03:45:03 GMT) Full text and rfc822 format available.

Message #10 received at 657751@bugs.debian.org (full text, mbox):

From: Paul Wise <pabs@debian.org>
To: 657751@bugs.debian.org
Cc: control <control@bugs.debian.org>
Subject: gdm3: 657751: patch to fix purging when gdm3 is running
Date: Sun, 11 Mar 2012 11:41:09 +0800
[Message part 1 (text/plain, inline)]
tags 657751 + patch
thanks

The issue seems to be that userdel doesn't allow removal when a user is
still in use and gdm3 uses the Debian-gdm user to run parts of itself.

The prerm already tries to stop gdm3 when there is no user logged in and
in this case it seems that there is a user logged in so it doesn't stop.

Killing an active user session doesn't seem to be appropriate,
especially since it could be controlling the dpkg/apt process running
the postrm script.

However, that is all moot because the postrm script should not fail
since it ignores any success/failure of deluser.

It appears the stdout and stderr of userdel is leaking into the code
that purges info from the debconf db. Obviously that output is not a
valid command stream for db_purge so it fails.

If we load the debconf confmodule before generating any output, then the
code in the debconf confmodule will handle redirecting stdout/stderr
correctly so that there are no failures, patch below:

--- gdm3-3.0.4/debian/gdm3.postrm
+++ gdm3-3.0.4/debian/gdm3.postrm
@@ -1,6 +1,13 @@
 #!/bin/sh
 set -e
 
+# Need to load this before any output on stdout/stderr
+# otherwise the debconf command-stream will get
+# some invalid input and cause the failure of postrm.
+if [ "$1" = purge ] && [ -e /usr/share/debconf/confmodule ]; then
+        . /usr/share/debconf/confmodule
+fi
+
 if [ "$1" = "purge" ] ; then
         update-rc.d gdm3 remove >/dev/null
         if [ -d /etc/gdm3 ]; then

-- 
bye,
pabs

http://wiki.debian.org/PaulWise
[signature.asc (application/pgp-signature, inline)]

Added tag(s) patch. Request was from Paul Wise <pabs@debian.org> to control@bugs.debian.org. (Sun, 11 Mar 2012 03:45:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>:
Bug#657751; Package gdm3. (Thu, 24 May 2012 09:30:37 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sergio Villar Senin <svillar@igalia.com>:
Extra info received and forwarded to list. Copy sent to Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>. (Thu, 24 May 2012 09:30:44 GMT) Full text and rfc822 format available.

Message #17 received at 657751@bugs.debian.org (full text, mbox):

From: Sergio Villar Senin <svillar@igalia.com>
To: 657751@bugs.debian.org
Subject: gdm3: error on package purge
Date: Thu, 24 May 2012 11:29:49 +0200
Is there any reason why this patch hasn't been applied yet? This is a RC
and there has been a patch available since March. 3.4 has been out for a
while right now and we got stuck in 3.0. I can help with debugging if
needed.

BR




Information forwarded to debian-bugs-dist@lists.debian.org, Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>:
Bug#657751; Package gdm3. (Sun, 02 Sep 2012 19:45:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Salvatore Bonaccorso <carnil@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>. (Sun, 02 Sep 2012 19:45:05 GMT) Full text and rfc822 format available.

Message #22 received at 657751@bugs.debian.org (full text, mbox):

From: Salvatore Bonaccorso <carnil@debian.org>
To: Paul Wise <pabs@debian.org>, 657751@bugs.debian.org, Sergio Villar Senin <svillar@igalia.com>
Subject: Re: Bug#657751: gdm3: 657751: patch to fix purging when gdm3 is running
Date: Sun, 2 Sep 2012 21:41:21 +0200
[Message part 1 (text/plain, inline)]
Hi

Looking at wheezy bugs to be fixed I stumbled over #657751 in gdm3.
Sergio, are you able to repoduce this with current version in wheezy?

I tried to reproduce this via an installation in a VM, login in a user
and then purging gdm3. The removal went without the problems
described.

[But anyway, Paul already did an analysis which in any case (even not
triggered here) should further 'stabilize' the possible purge process
for gdm3.]

Thoughts?

Regards,
Salvatore
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>:
Bug#657751; Package gdm3. (Mon, 03 Sep 2012 13:57:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sergio Villar Senin <svillar@igalia.com>:
Extra info received and forwarded to list. Copy sent to Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>. (Mon, 03 Sep 2012 13:57:02 GMT) Full text and rfc822 format available.

Message #27 received at 657751@bugs.debian.org (full text, mbox):

From: Sergio Villar Senin <svillar@igalia.com>
To: Salvatore Bonaccorso <carnil@debian.org>
Cc: Paul Wise <pabs@debian.org>, 657751@bugs.debian.org
Subject: Re: Bug#657751: gdm3: 657751: patch to fix purging when gdm3 is running
Date: Mon, 03 Sep 2012 15:53:04 +0200
En 02/09/12 21:41, Salvatore Bonaccorso escribiu:
> Hi
> 
> Looking at wheezy bugs to be fixed I stumbled over #657751 in
> gdm3. Sergio, are you able to repoduce this with current version in
> wheezy?

I'm running sid right now, and all I can say is that I am not able to
reproduce it with the current unstable version (gdm3_3.4.1-2_amd64.deb)

BR



Information forwarded to debian-bugs-dist@lists.debian.org, Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>:
Bug#657751; Package gdm3. (Sun, 30 Sep 2012 09:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to intrigeri <intrigeri@boum.org>:
Extra info received and forwarded to list. Copy sent to Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>. (Sun, 30 Sep 2012 09:27:03 GMT) Full text and rfc822 format available.

Message #32 received at 657751@bugs.debian.org (full text, mbox):

From: intrigeri <intrigeri@boum.org>
To: Sergio Villar Senin <svillar@igalia.com>
Cc: 657751@bugs.debian.org, Salvatore Bonaccorso <carnil@debian.org>, Paul Wise <pabs@debian.org>
Subject: Re: Bug#657751: gdm3: 657751: patch to fix purging when gdm3 is running
Date: Sun, 30 Sep 2012 11:25:26 +0200
Hi,

Salvatore Bonaccorso wrote (02 Sep 2012 19:41:21 GMT) :
> [But anyway, Paul already did an analysis which in any case (even
> not triggered here) should further 'stabilize' the possible purge
> process for gdm3.]

Sergio Villar Senin wrote (03 Sep 2012 13:53:04 GMT) :
> I'm running sid right now, and all I can say is that I am not able
> to reproduce it with the current unstable version
> (gdm3_3.4.1-2_amd64.deb)

I suggest #657751 is cloned, the new bug retitled to "improve handling
or userdel output in postrm", its severity set to normal, and the
original #657751 closed. I'm happy to do it if the GNOME maintainers
give their go ahead.

Thoughts?



Information forwarded to debian-bugs-dist@lists.debian.org, Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>:
Bug#657751; Package gdm3. (Thu, 25 Oct 2012 21:06:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Simon McVittie <smcv@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>. (Thu, 25 Oct 2012 21:06:06 GMT) Full text and rfc822 format available.

Message #37 received at 657751@bugs.debian.org (full text, mbox):

From: Simon McVittie <smcv@debian.org>
To: Salvatore Bonaccorso <carnil@debian.org>, 657751@bugs.debian.org
Cc: Paul Wise <pabs@debian.org>, Sergio Villar Senin <svillar@igalia.com>
Subject: Re: Bug#657751: gdm3: 657751: patch to fix purging when gdm3 is running
Date: Thu, 25 Oct 2012 22:03:58 +0100
clone 657751 -1
retitle -1 '/etc/init.d/gdm3 stop' does not terminate Debian-gdm's dbus-daemons etc.
severity -1 normal
thanks

On Sun, 02 Sep 2012 at 21:41:21 +0200, Salvatore Bonaccorso wrote:
> I tried to reproduce this via an installation in a VM, login in a user
> and then purging gdm3. The removal went without the problems
> described.

Perhaps you didn't have a complete GNOME system, only gdm3 itself? I can
reproduce this in two ways:

* install the GNOME desktop task in a VM
* switch to tty1 and purge gdm3, gnome-core, gnome and task-gnome-desktop

and

* install the GNOME desktop task in a VM
* log in to X as a user (on tty7)
* user menu -> Switch User (moves you to tty8 with a GDM "greeter")
* switch to tty1 and purge gdm3, gnome-core, gnome and task-gnome-desktop

Not all of the "greeter" processes die when /etc/init.d/gdm3 stop is run:

default|archetype% ssh wheezy-desktop ps -U Debian-gdm -u Debian-gdm u        ~
USER       PID %CPU %MEM    VSZ   RSS TTY      STAT START   TIME COMMAND
108       2842  0.0  0.1  30188  1192 ?        Ss   21:25   0:00 /usr/bin/dbus-daemon --fork --print-pid 5 --print-address 7 --session
108       2864  0.0  0.2  53628  2328 ?        S    21:25   0:00 /usr/lib/gvfs/gvfsd
108       2870  0.0  0.3 152956  3296 ?        Sl   21:25   0:00 /usr/lib/at-spi2-core/at-spi-bus-launcher
108       2874  0.0  0.1  29920  1508 ?        S    21:25   0:00 /usr/bin/dbus-daemon --config-file=/etc/at-spi2/accessibility.conf --nofork --print-address 3

> [But anyway, Paul already did an analysis which in any case (even not
> triggered here) should further 'stabilize' the possible purge process
> for gdm3.]

This does seem to fix it; I've uploaded it.

    S



Bug 657751 cloned as bug 691458 Request was from Simon McVittie <smcv@debian.org> to control@bugs.debian.org. (Thu, 25 Oct 2012 21:06:07 GMT) Full text and rfc822 format available.

Reply sent to Simon McVittie <smcv@debian.org>:
You have taken responsibility. (Thu, 25 Oct 2012 21:06:11 GMT) Full text and rfc822 format available.

Notification sent to Yann Dirson <ydirson@free.fr>:
Bug acknowledged by developer. (Thu, 25 Oct 2012 21:06:11 GMT) Full text and rfc822 format available.

Message #44 received at 657751-close@bugs.debian.org (full text, mbox):

From: Simon McVittie <smcv@debian.org>
To: 657751-close@bugs.debian.org
Subject: Bug#657751: fixed in gdm3 3.4.1-4
Date: Thu, 25 Oct 2012 21:02:30 +0000
Source: gdm3
Source-Version: 3.4.1-4

We believe that the bug you reported is fixed in the latest version of
gdm3, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 657751@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Simon McVittie <smcv@debian.org> (supplier of updated gdm3 package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Format: 1.8
Date: Thu, 25 Oct 2012 21:31:25 +0100
Source: gdm3
Binary: gdm3
Architecture: source amd64
Version: 3.4.1-4
Distribution: unstable
Urgency: low
Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
Changed-By: Simon McVittie <smcv@debian.org>
Description: 
 gdm3       - Next generation GNOME Display Manager
Closes: 657751
Changes: 
 gdm3 (3.4.1-4) unstable; urgency=low
 .
   * Team upload
   * Apply patch from Paul Wise to avoid userdel error messages
     from being used as input for debconf if gdm3 is purged while
     processes are still running as Debian-gdm (Closes: #657751)
Checksums-Sha1: 
 dcb6cb0d82d50eb0bd8fdf90dbc6c910b77f4e2f 2694 gdm3_3.4.1-4.dsc
 d87d373a05a656243df32f04d0bdb37bd40e7969 120830 gdm3_3.4.1-4.debian.tar.gz
 3d5e25757b49bebb597c37b0dc71450d0e9aa26a 762184 gdm3_3.4.1-4_amd64.deb
Checksums-Sha256: 
 be7e0785ba1e3e915418acc4d5311aa6888a42ecd28c89ba4964182e41e20689 2694 gdm3_3.4.1-4.dsc
 3d81c5b31d323d6002aa7c933ac9312273bd3e0e0156309bf3126aaf62fcfa5c 120830 gdm3_3.4.1-4.debian.tar.gz
 b2010e9735cb79c5778d8bd5b12250478d163e26c0b5785ae09f500119bb5d6c 762184 gdm3_3.4.1-4_amd64.deb
Files: 
 98d03ccda01e90c1086ac7fda800de00 2694 gnome optional gdm3_3.4.1-4.dsc
 6d02ef5fc7a54631f4b0d29b710a5d72 120830 gnome optional gdm3_3.4.1-4.debian.tar.gz
 d629b2d1e2dc7d9001b9779f9a7f8616 762184 gnome optional gdm3_3.4.1-4_amd64.deb

-----BEGIN PGP SIGNATURE-----

iQIVAwUBUImmJk3o/ypjx8yQAQhtjg//QvQmDV/eaLUQxiJnqq+/itZEqQ57tZXQ
1cFDpf2Kc7/ftWXzzUxOE2bn58VEfmIxODvyrvg3V2avdGetoRZnxLh8IeN1dzoN
jW+NOhen/DonL+L6B9xjwV7RFNmu/OhiG1j7lSmSP3nOLOEeskNTEDXl2eT/RD3m
r5+8cJd6fUkdr17RyG9Shrizx3JwvF9RjiPWtQCiRV0SHD1QIZm5N4wqe7PwVtBK
JCh86Z9GOVGiReZNiTftMsZzO1ch9QXoXcjLnvpXWPTrVQISVFTwY/RHdYhspA6m
0TnGJ69vJUkYiDtdnM2J8VXNzRuy/NfSFa3V7XbfPahpyfyhMvQWd7wnDKS45vDO
obtZa4azf0rSPo6k2s2ptyILQ8kgZpOSvawlAGUhoe1ktky4hvW8lu2xyEQzPf6G
VzS0TXRL7KeHrW5ykn04AR+GeAmPviHfV5U7Mgz4ST+gBEZairEyUrWacPf2EPuK
HtSA7nGVuyXFHgSad4MuP8DK2lAL5CnQfrmFozxHRIbEKwjobEGVlFyyQ50iIwii
Ng30E7CviEPPEOY3rqjOwooCuNdqh25vSjPnTylqwujw0xIq0OXixj41EX5mI/H8
bGX61P4EKXK8K1VA3Qp1SoY8ig7t6UonjBt58C3mAgCIRoNwOmYednls2wbpVnzs
slQ/Jn8STxU=
=ZdqH
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 03 Dec 2012 07:28:07 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 16:32:10 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.